	name	banner
	page	55,132
	title	'BANNER.EXE --- display message to screen'
	.286


cr	equ	0dh			; ASCII carriage return
lf	equ	0ah			; ASCII line feed

cseg	segment	public	'CODE'

	assume	cs:cseg,ds:cseg,es:cseg

byte0:					; Label used to calculate code size

;* Select the appropriate line below depending on the size of the USER Area
;* in your system.

;	db	55h,0AAh,08h		; 4K USER Area
	db	55h,0AAh,10h		; 8K USER Area

Banner	PROC	FAR			; MUST be a FAR procedure

	JMP	short start		; This is BYTE 3 (fourth byte) and
					; Must be the entry point into the
					; code

;* Select the appropriate text below depending on the size of the USER Area
;* in your system.

;prompt	db  cr,lf,'Welcome to the 4K FLASH User Area!',cr,lf,0	; 4K USER Area
prompt 	db  cr,lf,'Welcome to the 8K FLASH User Area!',cr,lf,0	; 8K USER Area


start:					; Start of actual code
	pusha				; Save all registers
	mov	ax,cs			; Initialize segment registers
	mov	ds,ax			; appropriately
	mov	es,ax
	mov	si,offset prompt	; Point to text string
	mov	ah,03			; Prepare for interrupt 10h call
	mov	bh,0			; to read the current cursor position
	int	10h			; Do the interrupt
	inc	dh			; Prepare to set cursor to next row
	mov	dl,0			; Prepare to set cursor to column 0
	mov	ah,2			; Prepare to set cursor position as
	mov	bh,0			; defined above
	int	10h			; Do the interrupt

display_loop:				; Loop to display banner on screen
	mov	ah,0eh			; Prepare for interrupt 10h call
	mov	bh,0			; to write character to screen
	mov	al,byte ptr cs:[si]	; Get character to display
	inc	si			; Point to next character
	cmp	al,0			; Are we finished?
	je	exit			; If so then leave
	int	10h			; Else do the interrupt

	inc	dl			; Prepare to set cutsor to next column
	mov	ah,2
	mov	bh,0
	int	10h			; Do the interrupt
	jmp	display_loop		; Go do it all again

exit:
	popa				; Restore all registers

	RET				; Return to BIOS (FAR Return)

;* Select the appropriate line below depending on the size of the USER Area
;* in your system.  This equate will be the remaining space in the User
;* Area following the code.

;pad	equ	1000h-($-byte0)		; 4K USER Area
pad	equ	2000h-($-byte0)		; 8K USER Area

	db	pad dup(0)		; Fill rest of USER Area with nulls

Banner		ENDP			; End of Banner procedure

cseg	ends				; End of CSEG segment

end	start				; End of code, Label of Beginning 
					; of code
